# Asset for AI-RON MAN Web Application 

This asset allows to start a web application made up by a Graphical User Interface
and a backend service that exposes ReST API to fetch fire hazard risk data from
projects storage spaces.

## Asset files

Within the (unzipped) folder there are the following files:
1. the file `docker-compose.yaml` that manages the start-up of the whole application by running all services
2. the file `Dockerfile` which contains specific instructions needed by the Docker engine to build the image
3. the tar archive `asset-fe-base` that contains a Docker filesystem needed by the application to start 
4. this README

## Start
### Requirements

Requirements to start the application
- [Docker](https://docs.docker.com/)

### Installation

After downloading the zipped asset folder, please unzip it, put it into a known location and go into the 
(unzipped) folder.
After opening a terminal, by means of the command `ls` you will be able to explore the content of the asset folder
and check that all the modules listed in the previous section are present.
To begin with, please digit the command

```shell
docker import ./asset-fe-base.tar asset-fe-base:latest
```

This will import the tar archive `asset-fe-base` and create a Docker image
needed by the application under the name `asset-fe-base`.
Now, in order to start the application, you need to launch the build command

```shell
docker build -t asset-fe-img -f ./Dockerfile .
```
Before starting the application it is **mandatory** to build the image
of the backend service provided by the asset `backend`. 
Please follow the README of this asset in order to build the image required here as well.

Once these steps have been carried out, we are now able to launch the application using the command:

```shell
docker compose up
```
This command will manage to start up all containers needed by the application,
in particular both the frontend and the backend part.
The application will be up and running once you will see on the logs printed something like

```shell
INFO:     Application startup complete.
```

The web application will be available on the local address 

```shell
localhost:80
```

### 3D BIM Model Viewer
The application allows to view 3-dimensional BIM models related to the Digital Twin of a Base Radio Station.  
In order to accomplish it, the application relies on a proprietary cloud service that might not be available
at all times due to maintenance operations.  
If you can't correctly view the model, please follow the support section in this readme.


## Support

If you have trouble running this application, please contact us at
[team.turing@stamtech.com](mailto:team.turing@stamtech.com).

## Created with

- [Angular](https://angular.io/)
- [FastAPI](https://fastapi.tiangolo.com/)
- [Docker](https://docs.docker.com/)

